require 'json' 
require 'shellwords' 

class RabbitMqConsumerCheck
  def initialize(url)
    @json = JSON.parse(`curl -s #{url.shellescape}`).inject({}) do |hash, item|
      hash[item["name"]] = item
      hash
    end
  end

  def consumer_alive_on_queue?(queue_name)
    unless queue = @json[queue_name]
      puts "#{Time.now} ERROR: #{queue_name} not found"
      return false
    end

    unless queue["consumers"] == 1
      puts "#{Time.now} ERROR: #{queue_name} no consumers"
      return false 
    end

    if queue["messages"] == 0
      return true
    end

    last_message_delivered = queue["message_stats"]["deliver_get_details"]["last_event"] rescue 0
    last_message_published = queue["message_stats"]["publish_details"]["last_event"] rescue 0

    message_age_ms = (last_message_delivered - last_message_published).abs

    if message_age_ms > 60 * 1000 # 1 Minute
      puts "#{Time.now} ERROR: #{queue_name} last message too old (#{message_age_ms}ms)"
      return false
    end

    return true
  end
end
